/*
 * This software is the confidential and proprietary information of
 * Smardec. You shall not disclose or distribute such Confidential Information.
 * This software shall not be integrated, copied (partially or fully),
 * or reverse engineered into any other software, program, or code that is
 * not intended for Smardec. You shall use it only in accordance with the terms
 * of the license agreement you entered into with Smardec.
 *
 * Copyright (C) 2004-2006 Smardec. All rights reserved.
 *
 * http://www.smardec.com
 *
 */

package com.smardec.demo.j2native.linux.usermanager.info;

import com.smardec.demo.j2native.tools.Cachable;

import java.util.ArrayList;
import java.util.List;

public class GroupInfo implements Cachable {
    public static final GroupInfo UNKNOWN_GROUP = new GroupInfo(-1, "Unknown");
    private String groupName;
    private String groupPass;
    private int groupId;
    private List groupMembers;

    public GroupInfo(int groupId, String groupName) {
        this.groupId = groupId;
        this.groupName = groupName;
    }

    protected GroupInfo(GroupInfo giOriginal) {
        this(giOriginal.getId(), giOriginal.getGroupName());

        this.groupPass = giOriginal.getGroupPass();
        this.groupMembers = new ArrayList(giOriginal.getGroupMembers());
    }

    public int getId() {
        return groupId;
    }

    public List getGroupMembers() {
        return groupMembers;
    }

    public void setGroupMembers(List groupMembers) {
        this.groupMembers = groupMembers;
    }

    public String getGroupPass() {
        return groupPass;
    }

    public void setGroupPass(String groupPass) {
        this.groupPass = groupPass;
    }

    public String getGroupName() {
        return groupName;
    }

    public String getIdent() {
        return getGroupName();
    }

    public static GroupInfo clone(Object giOriginal) {
        if (giOriginal instanceof GroupInfo) {
            return new GroupInfo((GroupInfo) giOriginal);
        }
        return null;
    }

    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        } else if (obj instanceof GroupInfo) {
            return getId() == ((GroupInfo) obj).getId();
        }
        return false;
    }

}
