package com.smardec.demo.j2native.demos;

import com.smardec.demo.j2native.DemoableAdapter;
import com.smardec.demo.j2native.Util;
import com.smardec.demo.j2native.linux.info.UserInfo;
import com.smardec.demo.j2native.linux.j2n.J2NConstants;
import com.smardec.demo.j2native.tools.LibraryManager;
import com.smardec.demo.j2native.tools.SysInfoUtil;
import com.smardec.j2native.Library;
import com.smardec.j2native.LibraryNotFoundException;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.*;
import java.io.IOException;
import java.net.ServerSocket;
import java.util.Vector;

public class LinUserManagerDemo extends DemoableAdapter implements J2NConstants {
    public final static String CONSTRAINT_LIN_USER_MANAGER = "LinUserManager";
    public final static String CAPTION_LIN_USER_MANAGER = "User manager";
    public final static String INTRO_LIN_USER_MANAGER = "<html><p align=left color=black>JOutlookPanel</p></html>";

    private JPanel jPanelOptions = null;
    private JPanel jPanelDesc = null;

    private UserInfo currentUser;
    private static int PORT = 13 * 666 + 7;
    private static ServerSocket listenerSocket;


    public String getID() {
        return CONSTRAINT_LIN_USER_MANAGER;
    }

    public String getCaption() {
        return CAPTION_LIN_USER_MANAGER;
    }

    public Vector getContentDescriptions() {
        return null;
    }

    public int getState() {
        return STATE_NONE;
    }

    public JPanel getDemoPanel() {
        JPanel jPanelContents = new JPanel(new GridBagLayout());
        TitledBorder titledBorder = BorderFactory.createTitledBorder(CAPTION_LIN_USER_MANAGER);
        titledBorder.setTitleColor(Color.black);
        jPanelContents.setBorder(titledBorder);

        Util.constrain(jPanelContents, new JScrollPane(new com.smardec.demo.j2native.linux.LinuxDemoPanel()),
                0, 0, 1, 1, GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST, 1, 1,
                0, 5, 0, 5);
        return jPanelContents;
    }

    public JPanel getOptionPanel() {
        if (jPanelOptions != null)
            return jPanelOptions;
        return null;
    }

    public JPanel getDescriptionPanel() {
        if (jPanelDesc != null)
            return jPanelDesc;

        jPanelDesc = new JPanel(new GridBagLayout());
        Util.constrain(jPanelDesc, new JLabel(INTRO_LIN_USER_MANAGER),
                0, 1, 1, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST, 1.0, 1.0,
                5, 5, 5, 5);
        Util.constrain(jPanelDesc, Box.createGlue(),
                0, 2, 1, 1, GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST, 1.0, 1.0,
                0, 0, 0, 0);
        return jPanelDesc;
    }

    public void deinit() {
        resetLibManager();
    }

    public void init(Component parentFrame) {
//        if (SysInfoUtil.isUnix()) {
//            System.setProperty(Library.LIBRARY_ENFORCE_KEY, Boolean.FALSE.toString());
//            Library.ensureNativeCodeLoaded();
//            initLibManager();
//
//        }
//        if (!ensureOneInstance()) {
//            resetLibManager();
//            throw new IllegalStateException("Only one instance allowed.");
//        }
//
//        RefreshHelper.refresh(!SysInfoUtil.isUnix());
//        int userId = InfoProvider.getInfoProvider().getCurrentUserId();
//        currentUser = UserManager.getInstance().getUserInfo(userId);
    }

    private static void resetLibManager() {
        LibraryManager.getInstance().reset();
    }

    private static void initLibManager() {
        LibraryManager libManager = LibraryManager.getInstance();
        Library library = new Library(KERNEL_NAME);
        try {
            libManager.registerLibrary(library);
        } catch (LibraryNotFoundException e) {
            library = new Library(KERNEL_NAME_SECONDARY);
            libManager.registerLibrary(KERNEL_NAME, library);
        }
    }


    protected boolean ensureOneInstance() {
        try {
            listenerSocket = new ServerSocket(PORT);
        } catch (java.net.BindException e) {
            return false;
        } catch (final IOException e) { // an unexpected exception occurred
            return true;
        }
        return true;
    }

    public boolean isRoot() {
        return currentUser.getId() == 0;
    }

}
